import type { PropType } from 'vue';
import { defineComponent, onMounted, ref, watch } from 'vue'
import { useUserStore } from '@store/UserStore'
import type { IUserFields } from 'model';
import { IImgGallery, IUserProfile } from 'model'
import { costanti } from '@costanti'
import { shared_consts } from '@src/common/shared_vuejs'
import { tools } from '@tools'
import { useQuasar } from 'quasar'
import { useI18n } from 'vue-i18n'
import { useRoute, useRouter } from 'vue-router'

export default defineComponent({
  name: 'CMyUserOnlyView',
  emits: ['setCmd'],
  props: {
    mycontact: {
      type: Object as PropType<IUserFields | null>,
      required: false,
      default: null,
    },
    myusername: {
      type: String,
      required: false,
      default: null,
    },
    visu: {
      type: Number,
      required: true,
    },
    groupname: {
      type: String,
      required: false,
      default: '',
    },
    circuitname: {
      type: String,
      required: false,
      default: '',
    },
    name: {
      type: String,
      required: false,
      default: '',
    },
    labelextra: {
      type: String,
      required: false,
      default: '',
    },
    labelFooter: {
      type: String,
      required: false,
      default: '',
    },
    notsetcmd: {
      type: Boolean,
      required: false,
      default: false,
    }
  },

  setup(props, { emit }) {

    const userStore = useUserStore()
    const $q = useQuasar()
    const { t } = useI18n()
    const $router = useRouter()
    const $route = useRoute()

    const username = ref('')

    const contact = ref(<IUserFields | null>null)

    watch(() => props.mycontact, (newval, oldval) => {
      console.log('watch: mycontact')
      mounted()
    })

    function mounted() {
      if (!props.mycontact) {
        if (props.myusername) {
          username.value = props.myusername
          //++Todo: carica contact
          contact.value = null
        }
      } else {
        if (props.mycontact) {
          contact.value = props.mycontact
          username.value = props.mycontact.username
        }
      }
    }

    function getImgUser(profile: IUserFields) {
      return userStore.getImgByProfile(profile)
    }

    function naviga(path: string) {
      $router.push(path)
    }

    function setCmd($q: any, cmd: number, myusername: string, value: any, dest: string) {
      if (props.notsetcmd) {
        tools.setCmd($q, cmd, myusername, value, dest)
      } else {
        emit('setCmd', $q, cmd, myusername, value, dest)
      }
    }

    onMounted(mounted)

    return {
      contact,
      costanti,
      getImgUser,
      naviga,
      setCmd,
      shared_consts,
      userStore,
      tools,
    }
  },
})
